osgTerrain::Locator Class Reference

`#include <Locator>`

Inheritance diagram for osgTerrain::Locator:

## Public Types

enum | CoordinateSystemType { GEOCENTRIC , GEOGRAPHIC , PROJECTED }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Locator ()
| Locator (const Locator &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgTerrain, Locator)
void | setCoordinateSystemType (CoordinateSystemType type)
CoordinateSystemType | getCoordinateSystemType () const
void | setFormat (const std::string &format)
const std::string & | getFormat () const
void | setCoordinateSystem (const std::string &cs)
const std::string & | getCoordinateSystem () const
void | setEllipsoidModel (osg::EllipsoidModel *ellipsode)
osg::EllipsoidModel * | getEllipsoidModel ()
const osg::EllipsoidModel * | getEllipsoidModel () const
void | setTransform (const osg::Matrixd &transform)
const osg::Matrixd & | getTransform () const
void | setTransformAsExtents (double minX, double minY, double maxX, double maxY)
virtual bool | orientationOpenGL () const
virtual bool | convertLocalToModel (const osg::Vec3d &local, osg::Vec3d &world) const
virtual bool | convertModelToLocal (const osg::Vec3d &world, osg::Vec3d &local) const
bool | computeLocalBounds (Locator &source, osg::Vec3d &bottomLeft, osg::Vec3d &topRight) const
void | setDefinedInFile (bool flag)
bool | getDefinedInFile () const
void | setTransformScaledByResolution (bool scaledByResolution)
bool | getTransformScaledByResolution () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static bool | convertLocalCoordBetween (const Locator &source, const osg::Vec3d &sourceNDC, const Locator &destination, osg::Vec3d &destinationNDC)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Member Functions

virtual | ~Locator ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

CoordinateSystemType | _coordinateSystemType
std::string | _format
std::string | _cs
osg::ref_ptr< osg::EllipsoidModel > | _ellipsoidModel
osg::Matrixd | _transform
osg::Matrixd | _inverse
bool | _definedInFile
bool | _transformScaledByResolution
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Enumeration Documentation

## CoordinateSystemType

enum osgTerrain::Locator::CoordinateSystemType

CoordinateSystemType provides the classification of the type coordinate system represented.

Enumerator
GEOCENTRIC | GEOCENTRIC coordinate systems are ones mapped to the around the ellipsoid, i.e. whole earth.
GEOGRAPHIC | GEOGRAPHIC coordinate systems are ones mapped to latitude and longitude.
PROJECTED | PROJECTED coordinate systems are ones projected to a local projected coordinate system i.e. UTMs.

## Constructor & Destructor Documentation

## Locator() [1/2]

osgTerrain::Locator::Locator | ( |  | ) |

Referenced by computeLocalBounds(), convertLocalCoordBetween(), Locator(), and META_Object().

## Locator() [2/2]

osgTerrain::Locator::Locator | ( | const Locator & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Locator(), and osg::CopyOp::SHALLOW_COPY.

## ~Locator()

virtual osgTerrain::Locator::~Locator | ( |  | ) |

protected virtual

## Member Function Documentation

## computeLocalBounds()

bool osgTerrain::Locator::computeLocalBounds | ( | Locator & | source,
|  | osg::Vec3d & | bottomLeft,
|  | osg::Vec3d & | topRight ) const

References Locator().

## convertLocalCoordBetween()

bool osgTerrain::Locator::convertLocalCoordBetween | ( | const Locator & | source,
|  | const osg::Vec3d & | sourceNDC,
|  | const Locator & | destination,
|  | osg::Vec3d & | destinationNDC )

inline static

References convertLocalToModel(), convertModelToLocal(), and Locator().

## convertLocalToModel()

virtual bool osgTerrain::Locator::convertLocalToModel | ( | const osg::Vec3d & | local,
|  | osg::Vec3d & | world ) const

virtual

Referenced by convertLocalCoordBetween().

## convertModelToLocal()

virtual bool osgTerrain::Locator::convertModelToLocal | ( | const osg::Vec3d & | world,
|  | osg::Vec3d & | local ) const

virtual

Referenced by convertLocalCoordBetween().

## getCoordinateSystem()

const std::string & osgTerrain::Locator::getCoordinateSystem | ( |  | ) | const

inline

Get the CoordinateSystem reference string.

References _cs.

## getCoordinateSystemType()

CoordinateSystemType osgTerrain::Locator::getCoordinateSystemType | ( |  | ) | const

inline

Get the CoordinatesSyetemType.

References _coordinateSystemType.

## getDefinedInFile()

bool osgTerrain::Locator::getDefinedInFile | ( |  | ) | const

inline

References _definedInFile.

## getEllipsoidModel() [1/2]

osg::EllipsoidModel * osgTerrain::Locator::getEllipsoidModel | ( |  | ) |

inline

Get the EllipsoidModel.

References _ellipsoidModel.

## getEllipsoidModel() [2/2]

const osg::EllipsoidModel * osgTerrain::Locator::getEllipsoidModel | ( |  | ) | const

inline

Get the const EllipsoidModel.

References _ellipsoidModel.

## getFormat()

const std::string & osgTerrain::Locator::getFormat | ( |  | ) | const

inline

Get the coordinate system format string.

References _format.

## getTransform()

const osg::Matrixd & osgTerrain::Locator::getTransform | ( |  | ) | const

inline

Set the transformation from local coordinates to model coordinates.

References _transform.

## getTransformScaledByResolution()

bool osgTerrain::Locator::getTransformScaledByResolution | ( |  | ) | const

inline

References _transformScaledByResolution.

## META_Object()

osgTerrain::Locator::META_Object | ( | osgTerrain | ,
|  | Locator | )

References Locator().

## orientationOpenGL()

virtual bool osgTerrain::Locator::orientationOpenGL | ( |  | ) | const

virtual

## setCoordinateSystem()

void osgTerrain::Locator::setCoordinateSystem | ( | const std::string & | cs | ) |

inline

Set the CoordinateSystem reference string, should be stored in a form consistent with the Format.

References _cs.

## setCoordinateSystemType()

void osgTerrain::Locator::setCoordinateSystemType | ( | CoordinateSystemType | type | ) |

inline

Set the CoordinatesSyetemType. Note, the user must keep the CoordinateSystemString consistent with the type of the CoordinateSystem.

References _coordinateSystemType.

## setDefinedInFile()

void osgTerrain::Locator::setDefinedInFile | ( | bool | flag | ) |

inline

References _definedInFile.

## setEllipsoidModel()

void osgTerrain::Locator::setEllipsoidModel | ( | osg::EllipsoidModel * | ellipsode | ) |

inline

Set EllipsoidModel to describe the model used to map lat, long and height into geocentric XYZ and back.

References _ellipsoidModel.

## setFormat()

void osgTerrain::Locator::setFormat | ( | const std::string & | format | ) |

inline

Set the coordinate system format string. Typical values would be WKT, PROJ4, USGS etc.

References _format.

## setTransform()

void osgTerrain::Locator::setTransform | ( | const osg::Matrixd & | transform | ) |

inline

Set the transformation from local coordinates to model coordinates.

References _inverse, and _transform.

## setTransformAsExtents()

void osgTerrain::Locator::setTransformAsExtents | ( | double | minX,
|  | double | minY,
|  | double | maxX,
|  | double | maxY )

Set the extents of the local coords.

## setTransformScaledByResolution()

void osgTerrain::Locator::setTransformScaledByResolution | ( | bool | scaledByResolution | ) |

inline

References _transformScaledByResolution.

## Member Data Documentation

## _coordinateSystemType

CoordinateSystemType osgTerrain::Locator::_coordinateSystemType

protected

Referenced by getCoordinateSystemType(), and setCoordinateSystemType().

## _cs

std::string osgTerrain::Locator::_cs

protected

Referenced by getCoordinateSystem(), and setCoordinateSystem().

## _definedInFile

bool osgTerrain::Locator::_definedInFile

protected

Referenced by getDefinedInFile(), and setDefinedInFile().

## _ellipsoidModel

osg::ref_ptr<osg::EllipsoidModel> osgTerrain::Locator::_ellipsoidModel

protected

Referenced by getEllipsoidModel(), getEllipsoidModel(), and setEllipsoidModel().

## _format

std::string osgTerrain::Locator::_format

protected

Referenced by getFormat(), and setFormat().

## _inverse

osg::Matrixd osgTerrain::Locator::_inverse

protected

Referenced by setTransform().

## _transform

osg::Matrixd osgTerrain::Locator::_transform

protected

Referenced by getTransform(), and setTransform().

## _transformScaledByResolution

bool osgTerrain::Locator::_transformScaledByResolution

protected

Referenced by getTransformScaledByResolution(), and setTransformScaledByResolution().

The documentation for this class was generated from the following file:

- osgTerrain/Locator